#ifndef INTEGER_HPP
#define INTEGER_HPP


#include <iostream>
#include <sstream>
#include <list>

using namespace std;

typedef unsigned long ulong;
typedef unsigned short int usint;

class UInt{
public:
  class Data;
  typedef unsigned char Digit;
private:
  Data* data;
public:
  //Constructor
  UInt();
  UInt(const ulong&);
  UInt(const UInt&);
  UInt(const list<Digit>&);
  ~UInt();
  const UInt& operator=(const UInt&);

  //Comparasion
  bool operator==(const UInt&) const;
  bool operator!=(const UInt&) const;
  bool operator<(const UInt&) const;
  bool operator>(const UInt&) const;
  bool operator<=(const UInt&) const;
  bool operator>=(const UInt&) const;
  
  //Operation
  UInt operator+(const UInt&) const;
  UInt operator-(const UInt&) const;
  UInt operator*(const Digit&) const;
  UInt operator*(const UInt&) const;
  UInt mul_and_shift(const Digit&,const ulong&) const;
  
  pair<UInt,UInt> division(const UInt&) const;
  
  friend ostream& operator<<(ostream& os,const UInt&);
};

class UInt::Data{
  friend class UInt;
private:
  Data(ulong);
  Data(const list<Digit>&);
public:
  ulong nbref;
  Digit* digits; //digits[0] is for the unity (reverse of writting)
  ulong length;
  Data();
  ~Data();
  Data* get_own_copy();
};


inline bool
UInt::operator!=(const UInt &u) const{
  return not this->operator==(u);
}

inline bool
UInt::operator<=(const UInt &u) const{
  return not this->operator>(u);
}

inline bool
UInt::operator>=(const UInt &u) const{
  return not this->operator<(u);
}

#endif
